﻿// DoSpacesOK.jsx

/*
    
Программа делает гистограмму распределения ширин пробелов в выделенном тексте.
По горизонтали значения ширины, по вертикали -- число пробелов этой ширины.

Вся информация на кнопке [ ? ].
https://dotextok.ru
27.05.2025

*/

#targetengine "DoSpacesOK"

/*
Целочисленное деление ширины пробела на число 0,1 даст адрес сохранения информации о числе пробелов с этой шириной.
Если число равно нулю или больше 10,  то этот пробел в расчёт не берём. Пробелы шириной 10 пт, в обычном тексте таких нет.
*/

var ProgressBar = function(title) { // ProgressBar
var w = new Window('palette', title, {x:0, y:0, width:940, height:30},{closeButton: true});
pb = w.add('progressbar', {x:20, y:8, width:900, height:12});
w.center();
this.reset = function(maxValue) {
    pb.value = 0;
    pb.maxvalue = maxValue;
    w.show();
    w.update();
    }
this.hit = function() {++pb.value; w.update();}
this.hide = function() {w.hide();}
this.close = function() {w.close(); }
} // ProgressBar
////////////////////////////

var programTitul = "Шпационный смотритель";
var scriptFile = myGetScriptPath();
var scriptFolder = decodeURI(scriptFile.path);
if (scriptFolder.match ('Version') == null) {
    alert ("Скрипт должен быть размещён в пользовательской папке скриптов, она называется 'Пользователь'. В английской версии индизайна эта папка именуется 'User'.\r\rСейчас он или в папке демонстрационных скриптов 'Программа' ('Application'), или в папке 'Сообщество' (Community). Но в этих папках запрещено сохранять установки скрипта, чтобы восстановить их при следующем запуске.", programTitul);
    exit(); 
    }
var histDocID;
var sel;
var story;
var storyID;
var curNum;
var spacesNum;
var usedStyle;
var dupStyle;
var dupStyleSuffix = " (4-3i-n)";
var dupStyleSuffix_3 = " (4-3-n)"; // quarter-third-n
var dupStyleSuffix_i = " (4-i-n)"; // quarter-i-n
var dupStyleID = -1;
var selStory;
var fontSpaceWidthS, fontSpaceWidth, font_iWidthS, font_nWidthS, font_iWidth, font_nWidth, dotWidthS, dotWidth, usedParaStyle;
var upsKerning, upsTracking, upsMinW, upsDesW, upsMaxW, upsMinL, upsDesL, upsMaxL, upsMinG, upsDesG, upsMaxG, upsComposer;
var quotePointsize, thinSpace, thirdSpace;
var upsFont, upsKegl;
var theCondition = [];
var showSpaceCondition = "show-Space";
var colorLightBlue = [0, 209, 255];
var lastLineColor = "#lastLineColor";
var spacesArrSample = [];
var spaceSamples = [];
var spacesArr = {};
var lastLinesIndexes = [];
var tfLabel = "histInfo"; // эта метка для текстовых фреймов гистограммы, содержащих информацию о ширине пробела и числе таких пробелов
var paraStyles = [];    
var paraStyleID = []; 
while (paraStyles.length > 0) paraStyles.pop();
while (paraStyleID.length > 0) paraStyleID.pop();
////////
if(app.documents.length == 0) {
alert("Нет открытого документа.", programTitul);	
exit();    
}
var doc = app.activeDocument;
var allTF = doc.pages[0].textFrames.everyItem().getElements();
if (allTF.length == 0) {
    alert("Странный файл, нет ни одного текстового фрейма.", programTitul);	
    exit();  
    }
var doc = app.activeDocument;
var allTF = doc.pages[0].textFrames.everyItem().getElements();
if (allTF.length == 0) {
    alert("Странный файл, нет ни одного текстового фрейма.", programTitul);	
    exit();  
    }
var horUnit = doc.viewPreferences.horizontalMeasurementUnits;
doc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.POINTS;
var vertUnit = doc.viewPreferences.verticalMeasurementUnits;
doc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.POINTS;
var docName = decodeURI(doc.name);
var labelNotFound = true;
for (var i = 0; i < allTF.length; i++) { // i++
    if (allTF[i].label != tfLabel) continue;
    labelNotFound = false;
    break;
    } // i++
if (labelNotFound == false) { // ! labelNotFound
    alert("Активным файлом должен быть тот, для стилей которого создаются гистограммы. Сейчас открыт файл с гистограммой.", programTitul);	
    exit();     
    }
var noName = false;
//try { docPath = doc.filePath; } // если документ не сохранён, маршрут не сообщается
try { var fullName = decodeURI(doc.fullName); } // если документ не сохранён, маршрут не сообщается
catch(e) {
   alert("Это только что созданный и ещё ни разу не сохранённый файл.\nДайте ему имя.",programTitul); 
   noName = true;
    }
if (noName) { // noName
    try { doc.save(); }
    catch (e) {
         alert("Файл не был сохранён с новым именем.",programTitul);
         exit();
        }
    } // noName
var erInfo = 0;
if (app.documents.length > 1) { // > 0
    var allTF = app.documents[1].pages[0].textFrames.everyItem().getElements();
    if (allTF.length == 0) {
        erInfo = 1;
        }
    if (erInfo == 0) { // == 0
        var labelNotFound = true;
        for (var i = 0; i < allTF.length; i++) { // i++
            if (allTF[i].label != tfLabel) continue;
            labelNotFound = false;
            break;
            } // i++
        if (labelNotFound == true) { erInfo = 2; }       
        } // == 0
    if (erInfo != 0) {
        alert("Когда файлов больше одного, то активным должен быть файл вёрстки. Дополнительные файлы содержат гистограммы. Дополнительный файл есть, но гистограммы там нет. [" + erInfo + "].", programTitul);	
        exit();          
        }
    }  // > 0
var startDocID = doc.id;
collectParastyles();
if (paraStyles.length == 0) {
    alert("Нет абзацных стилей, созданных пользователем.", programTitul);
    exit();       
    }
app.clipboardPreferences.preferStyledTextWhenPasting = true;
///
var styleName = "";
var stylePosition = 0;
var myDefSetName  = "#hist.ini"; // это файл установок программы
var myScriptFile = myGetScriptPath();
var myScriptFolder = decodeURI(myScriptFile.path);
var setFolderPath = new Folder (myScriptFolder + "/" + "sets"); 
if (setFolderPath.exists == false) {   
    setFolderPath.create();
    }
var myFilePath = decodeURI(myScriptFolder + "/sets/" + myDefSetName); 
var myDataFile = new File (myFilePath);
if (myDataFile.open("r")) { // такой файл есть 
styleName = myDataFile.readln();
stylePosition = myDataFile.readln();
if (paraStyles[stylePosition] != styleName) stylePosition = 0;
myDataFile.close();
} // "r"
//////
function collectParastyles() { // collectParastyles
while (paraStyles.length > 0) paraStyles.shift();
while (paraStyleID.length > 0) paraStyleID.shift();
var adID = app.activeDocument.id;
app.activeDocument = app.documents.itemByID(startDocID);
var myParagraphStyles = app.activeDocument.allParagraphStyles;
var myParagraphStyleName, obj;
for (i = 0; i < myParagraphStyles.length ; i++) { // i++
    myParagraphStyleName = myParagraphStyles[i].name;
    if (myParagraphStyleName[0] == "[") continue;
    obj = myParagraphStyles[i];
    while(obj.parent instanceof ParagraphStyleGroup) {
        myParagraphStyleName = obj.parent.name + ":" + myParagraphStyleName;
        obj = obj.parent;        
        }
    paraStyles.push(myParagraphStyleName);
    paraStyleID.push(myParagraphStyles[i].id);
    } // i++
app.activeDocument = app.documents.itemByID(adID);
return;
} // collectParastyles
///
var win = new Window ("palette", programTitul);
win.alignChildren = ["fill", "fill"];
var makeHistogram = win.add("radiobutton", undefined, "Построить гистограмму ширин пробелов");
makeHistogram.value = true;
var styleGroup = win.add("group");
styleGroup.orientation = "row";
//styleGroup.enabled = true;
var style = styleGroup.add("dropdownlist");
var styleListLength = 110;
style.minimumSize.width = style.maximumSize.width = styleListLength;
updateList (style, paraStyles);
style.selection = stylePosition;
style.helpTip = String (style.selection);
styleGroup.add("statictext", undefined, "Исследуемый абзацный стиль");
///
var sepWidth = 50;
separator1 = win.add ("panel"); 
separator1.minimumSize.height = separator1.maximumSize.height = 1;
separator1.minimumSize.width = separator1.maximumSize.width = sepWidth;
separator1.alignment = ["left", "fill"];
var showSpaces = win.add("radiobutton", undefined, "Показать пробелы выбранного размера");
showSpaces.value = false;
if (app.documents.length == 1) showSpaces.enabled = false;
var spaceInfoGroup = win.add("group");
spaceInfoGroup.orientation = "row";
if (app.documents.length == 1) spaceInfoGroup.enabled = false;
var spaceValue = spaceInfoGroup.add ("edittext {justify: 'center'}", undefined);
spaceValue.characters = 8;
spaceValue.text = "– (–)";
if (app.documents.length == 1) spaceValue.enabled = false;
spaceInfoGroup.add("statictext", undefined, "ширина (число пробелов)");
///
var smallSize = [0,0,28,28];
///
separator2 = win.add ("panel"); 
separator2.minimumSize.height = separator2.maximumSize.height = 1;
separator2.minimumSize.width = separator2.maximumSize.width = sepWidth;
separator2.alignment = ["left", "fill"];
var changeSets = win.add("radiobutton", undefined, "Изменить установки ширины пробелов");
if (app.documents.length == 1) changeSets.enabled = false;
changeSets.value = false;
var bigGroup = win.add("group");
bigGroup.orientation = "column";
bigGroup.margins = [15,0,0,0];
var changeSetsGroup = bigGroup.add("group");
changeSetsGroup.orientation = "column";
changeSetsGroup.alignChildren = ["left", "top"];
changeSetsGroup.enabled = false;
var psChange = changeSetsGroup.add("radiobutton", undefined, "Сделать стиль" + dupStyleSuffix);
var defineDesiredSizeGroup = changeSetsGroup.add("group");
defineDesiredSizeGroup.margins = [20,0,0,0];
defineDesiredSizeGroup.orientation = "column";
defineDesiredSizeGroup.add("statictext", undefined, "Величина желаемого размера пробела");
var desiredSizeRadiobuttonGroup = defineDesiredSizeGroup.add("group");
desiredSizeRadiobuttonGroup.orientation = "row";
desiredSizeRadiobuttonGroup.alignment = ["left", "fill"];
var as_thirdSpace = desiredSizeRadiobuttonGroup.add("radiobutton", undefined, "третная шпация");
as_thirdSpace.value = true;
var as_letter_i = desiredSizeRadiobuttonGroup.add("radiobutton", undefined, "буква i");
as_letter_i.value = false;
psChange.value = true;
var psApply = changeSetsGroup.add("radiobutton", undefined, "Применение");
var applyGroup = changeSetsGroup.add("group");
applyGroup.orientation = "column";
applyGroup.alignChildren = ["left", "top"];
applyGroup.enabled = !psChange.value;
applyGroup.margins = [20,0,0,0];
var markLastLine = applyGroup.add("checkbox", undefined, "Отметить нижние строки на страницах");
var styleOldGroup = applyGroup.add("group");
styleOldGroup.orientation = "row";
var styleOld = styleOldGroup.add("dropdownlist");
var styleListLength = 110;
styleOld.minimumSize.width = styleOld.maximumSize.width = styleListLength;
updateList (styleOld, paraStyles);
styleOld.selection = stylePosition;
styleOld.helpTip = String (styleOld.selection);
styleOldGroup.add("statictext", undefined, "Заменяемый стиль");

var styleNewGroup = applyGroup.add("group");
styleNewGroup.orientation = "row";
var styleNew = styleNewGroup.add("dropdownlist");
var styleListLength = 110;
styleNew.minimumSize.width = styleNew.maximumSize.width = styleListLength;
updateList (styleNew, paraStyles);
styleNew.selection = stylePosition;
styleNew.helpTip = String (styleNew.selection);
styleNewGroup.add("statictext", undefined, "Новый стиль");

separator4 = win.add ("panel"); 
separator4.minimumSize.height = separator4.maximumSize.height = 1;
separator4.alignment = ["fill", "fill"];
var buttons = win.add("group");
buttons.orientation = "row";
buttons.alignChildren = ["center", "center"];
var info = buttons.add("button", [0,0,28,28], "?");
var action = buttons.add("button", [0,0,220,28], "Выполнить");
var hide = buttons.add("button", [0,0,28,28], "…");
///
psChange.onClick = function() { // psChange
psApply.value = false;    
applyGroup.enabled = false; 
defineDesiredSizeGroup.enabled = true;
} // psChange
///
markLastLine.onClick = function() { // markLastLine
if (markLastLine.value == false) { 
    while (lastLinesIndexes.length > 0) lastLinesIndexes.pop();
    try { app.activeDocument.colors.item(lastLineColor).remove(); } catch (e) {}
    return; 
    }
var _sel = app.selection[0];
if (_sel == null) { alert("Ничего не выделено.",programTitul); markLastLine.value = false; return; }
if (_sel.parent.parent.name != docName) { alert("Выделение не в файле вёрстки.",programTitul); markLastLine.value = false; return; }
if (_sel.constructor.name == "TextFrame" || _sel.hasOwnProperty("pointSize") != true || _sel.constructor.name == "InsertionPoint") {alert("Должна быть выделена область текста.",programTitul); markLastLine.value = false; return; }
selStory = _sel.parentStory;    
if (!app.activeDocument.colors.item(lastLineColor).isValid) { // ! (usedColor).isValid
    try { 
        app.activeDocument.colors.add ({name: lastLineColor, model:ColorModel.SPOT, space:ColorSpace.RGB, colorValue:[255, 0, 0]}) 
        } 
    catch (e) { } 
    } // ! (usedColor).isValid
while (lastLinesIndexes.length > 0) lastLinesIndexes.pop();
for (var i = 0; i < _sel.parentTextFrames.length; i++) { // i++    
    var linesNum = _sel.parentTextFrames[i].lines.length;
    var charsInLine = _sel.parentTextFrames[i].lines[linesNum-1].length;
    var endIndx = Number(_sel.parentTextFrames[i].lines[linesNum-1].characters[0].index) + Number(charsInLine) -1;
    lastLinesIndexes.push(_sel.parentTextFrames[i].lines[linesNum-1].characters[0].index + "|" + endIndx);
    } // i++
for (var i = 0; i < lastLinesIndexes.length; i++) { // i++
    var indexItem = lastLinesIndexes[i];
    var indArr = [];
    indArr = indexItem.split("|");
    selStory.characters.itemByRange(Number(indArr[0]), Number(indArr[1])).fillColor = app.activeDocument.colors.item(lastLineColor);
    } // i++
app.activeDocument.layoutWindows[0].screenMode = ScreenModeOptions.PREVIEW_OFF;
} // markLastLine
///
psApply.onClick = function() { // psApply
applyGroup.enabled = true; 
psChange.value = false;
defineDesiredSizeGroup.enabled = false;
updateList (styleOld, paraStyles);
styleOld.selection = Number(style.selection.index);
styleOld.helpTip = String (styleOld.selection);
updateList (styleNew, paraStyles);
styleNew.selection = Number(style.selection.index);
styleNew.helpTip = String (styleNew.selection);
} // psApply
///
styleOld.onActivate = function () { 
    var _stylePosition = Number(styleOld.selection.index);
    collectParastyles();
    updateList (styleOld, paraStyles);
    styleOld.selection = _stylePosition;
    styleOld.helpTip = String (styleOld.selection);  
    }
////
styleNew.onActivate = function () { 
    var _stylePosition = Number(styleNew.selection.index);
    collectParastyles();
    updateList (styleNew, paraStyles);
    styleNew.selection = _stylePosition;
    styleNew.helpTip = String (styleNew.selection);    
    }
///
makeHistogram.onClick = function () { // makeHistogram
makeHistogramAction();
} // makeHistogram 
///
hide.onClick = function() { // hide.onClick  
win.hide();
var needClear = true;
var slaveWinLocation = [-1,-1]; // положение на экране служебного окна программы
var wk = new Window ("palette", ">•<");
wk.margins = [1,1,1,1];
var myScriptFile = myGetScriptPath();
var myDefSetName  = "win=hide.ini"; // это файл установок программы
var myScriptFolder = decodeURI(myScriptFile.path);
var myFilePath = decodeURI(myScriptFolder + "/sets/" + myDefSetName); 
var myDataFile = new File (myFilePath);
if (myDataFile.exists) { //File.exists
    myDataFile.open("r");
    slaveWinLocation[0] = myDataFile.readln();
    slaveWinLocation[1] = myDataFile.readln();
    myDataFile.close();
    } //File.exists
if (slaveWinLocation[0] != -1) wk.location = slaveWinLocation;
var retButton = wk.add("button", [0,0,28,28], "<•>");
retButton.onClick = function() { // retButton
needClear = false;    
try { win.show(); } catch (e) {exit() };
myDataFile.open("w");
myDataFile.writeln(wk.location[0]);
myDataFile.writeln(wk.location[1]);
myDataFile.close();
wk.close();
} // retButton
///
wk.onClose = function() { 
if (needClear) theClearAndRestore(); // needClear = true - это случай, когда нажимают крестик в шапке свёрнутого окна.
app.activate();
}
///
wk.show();
}  // hide.onClick

///
function makeHistogramAction() { // makeHistogramAction
showSpaces.value = false;
changeSets.value = false;
spaceInfoGroup.enabled = false;
changeSetsGroup.enabled = false;
} // makeHistogramAction
///
///
showSpaces.onClick = function () { // showSpaces
makeHistogram.value = false;    
changeSets.value = false;
spaceInfoGroup.enabled = true;
///
changeSetsGroup.enabled = false;  
} // showSpaces
///
changeSets.onClick = function () { // changeSets
showSpaces.value = false;
makeHistogram.value = false;  
spaceInfoGroup.enabled = false;
changeSetsGroup.enabled = true;
} // changeSets
///
function clearCondition() { // clearCondition
while (theCondition.length > 0) theCondition.pop();
while (doc.conditions.length > 0) doc.conditions[-1].remove();
} // clearCondition
///
function updateList (style, paraStyles) { // updateList
if (style.items.length > 0) style.removeAll();
for (var t = 0; t < paraStyles.length; t++) style.add("item", paraStyles[t]);
} // updateList
///
style.onActivate = function () { 
    var _stylePosition = Number(style.selection.index);
    collectParastyles();
    updateList (style, paraStyles);
    style.selection = _stylePosition;
    style.helpTip = String (style.selection);
    makeHistogramAction();
    makeHistogram.value = true;
    }
///
action.onClick = function () { // action   
clearCondition(); 
if (makeHistogram.value == true) { // makeHistogram.value
    if (decodeURI(app.activeDocument.name) != docName) {
       alert("Это не тот документ, что был на экране в момент запуска данного скрипта. Тогда была работа с файлом '" + docName + "', а сейчас открыта другая работа.", programTitul);
       return;
        } 
    sel = app.selection[0];
    if (sel == null || (sel.constructor.name != "Paragraph" && sel.constructor.name != "Text" && sel.constructor.name != "TextColumn" && sel.constructor.name != "TextStyleRange")) {
        alert("Должен быть выделен текст, не меньше абзаца.",programTitul);
        return;    
        }
    try {
        var pTest = sel.characters[-1].parentTextFrames[0].parentPage.isValid == true;
        }
    catch(e) {
        alert("Похоже, тут есть вытесненный текст.", programTitul);
        return;    
        }
    if (sel.parent.constructor.name == "Footnote") {
        alert("Надо выделить основной текст, а не сноску.",programTitul);
        return;    
        }  
    var spaces = {};
    story= sel.parent;
    storyID = story.id;
    var pBar = new ProgressBar("Сбор информации о пробелах"); 
    var linesNum = sel.lines.length;
    pBar.reset(linesNum);
    var spMin = 99999;
    var spMax = 0;
    var spLength;
    var string, stringS, stringE;
    var spatios;
    var curSpace = "";
    while (spaceSamples.length > 0) spaceSamples.pop();
    app.activeDocument.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.POINTS;    
    for (var s = linesNum-1; s >= 0 ; s--, pBar.hit()) { // s--   
        string = sel.lines[s];
        if (string.length < 4) continue;
        app.findGrepPreferences = NothingEnum.nothing;
        app.changeGrepPreferences = NothingEnum.nothing;
        app.findChangeGrepOptions.includeFootnotes = true;    
        //app.findGrepPreferences.fillColor = "Black";    
        app.findGrepPreferences.horizontalScale = 100;
        app.findGrepPreferences.findWhat = " ";
        usedStyle = app.activeDocument.paragraphStyles.itemByID(paraStyleID[style.selection.index]);
        app.findGrepPreferences.appliedParagraphStyle = usedStyle;
        spatios = string.findGrep();
        stringS = string.horizontalOffset;
        stringE = string.endHorizontalOffset;
        for (var i = 0; i < spatios.length; i++) { // i++            
            spLength = Math.abs(spatios[i].endHorizontalOffset - spatios[i].horizontalOffset);
            if (spLength.toFixed(2) == 0) continue;
            if (Math.abs(stringS - spatios[i].horizontalOffset) < 1) continue;
            if (Math.abs(stringE - spatios[i].endHorizontalOffset) < 1) continue;            
            if (spLength > spMax) { spMax = spLength; }
            if (spLength < spMin) { spMin = spLength; }             
            curSpace = parseInt(spLength/0.1);       
            if (spaces[curSpace] == undefined) {
                spaces[curSpace] = 1;
                spacesArr[curSpace] = spatios[i].index;
                spaceSamples.push(curSpace);
                }
            else {
                spaces[curSpace] = Number(spaces[curSpace]) + Number(1);
                spacesArr[curSpace] = spacesArr[curSpace] + "," + spatios[i].index;  
                }
            } // i++    
        } // s--
    pBar.close();
    app.findGrepPreferences = NothingEnum.nothing;
    app.changeGrepPreferences = NothingEnum.nothing;
    doc.viewPreferences.horizontalMeasurementUnits = horUnit;
    if (spaceSamples.length == 0) {
        alert("Не найдены пробелы выбранного абзацного стиля.",programTitul);
        return;   
        }
    app.clipboardPreferences.preferStyledTextWhenPasting = true; // вставка буфера со всем оформлением
    getAllSpaceValues();
    var preset = app.documentPresets.add();
    preset.facingPages =  false;
    preset.pageHeight = "297mm";
    preset.pageWidth = "210mm";
    preset.bottom = "10mm";
    preset.left = "10mm";
    preset.right = "10mm";
    preset.top = "10mm";
    var  hist = app.documents.add(true,preset);
    var myT = hist.pages[0].textFrames.add({geometricBounds:["150mm","10mm","287mm","200mm"]});
    myT.strokeWeight = 0;
    if (myT.strokeWeight != 0) myT.strokeWeight = 0;
    myT.textFramePreferences.textColumnCount = 1;
    preset.remove();
    app.activeDocument = hist;
    var histogramColor = "#histogramColor";
    try { app.activeDocument.colors.add ({name: histogramColor, model: ColorModel.SPOT, space: ColorSpace.RGB, colorValue: [0,100,255]}); } 
    catch (e) { };  
    var histogramItemColor = "#histogramItemColor";
    try { app.activeDocument.colors.add ({name: histogramItemColor, model: ColorModel.SPOT, space: ColorSpace.RGB, colorValue: [255,0,255]}); } 
    catch (e) { }; 
    // Узнаем, сколько вариантов ширины пробела запомнено, чтобы определить длину основания фрейма отображения числа пробелов конкретной ширины.
    var spaceItemLength = 0;
    var countEmptyItems = 0; // подсчёт пропущенных значений возможных ширин пробела между ненулевыми значениями
    var firstItemFound = false;
    var sMax;
    for (var s = 1; s < 101; s++) { // s++
        if (spaces[s] == undefined && firstItemFound == false) continue;
        firstItemFound = true;
        if (spaces[s] == undefined) {
            countEmptyItems++;
            continue;
            }
        else {
            spaceItemLength = spaceItemLength + countEmptyItems + 1;
            countEmptyItems = 0;
            sMax = s;
            continue;
            }
        } // s++
    var bottomLength = 190/spaceItemLength; // 190 мм -- длина нижней части фрейма для гистограммы, spaceItemLength -- число задействованных градаций от 0,1 пт до 10 пт включительно.
    // bottomLength -- это величина основания.
    // Высота столбца гистограммы для самого большого числа равна 100 мм.
    var vertFactor;
    // vertFactor -- множитель для вычисления высот столбцов гистограммы, отображающих число пробелов.
    // Допустим, максимум -- это 50 пробелов. Они должны быть отражены линией в 100 мм.
    var spMaxNum = 0; // максимальное число пробелов одного размера
    var spMaxIndex = -1;
    for (var s = 1; s < 101; s++) { // s++
        if (spaces[s] == undefined) continue;
        if (spaces[s] > spMaxNum) {
            spMaxNum = spaces[s]; 
            spMaxIndex = s;
            }
        } // s++
    vertFactor = 100/spMaxNum; // в этом примере это 2.
    // Если другая линия это 20 пробелов, то её длина будет vertFactor х 20, или 40 мм
    //
    var yT, xT, yB, xB, tH, xLength, numCont, compareText;
    var deltaI = -1;
    xLength = 25;
    for (var i = 1; i <= sMax; i++) { // i++    
        if (spaces[i] == undefined && deltaI == -1) continue;
        if (deltaI == -1) deltaI = i;
        xB = Number(10) + Number(bottomLength)*(i-deltaI);
        xT = xB + Number(bottomLength);
        yB = Number(110);
        yT = yB - spaces[i] * vertFactor;
      if (spaces[i] != undefined) { // != undefined
          // рисуем столбец гистограммы
            tH = hist.pages[0].rectangles.add(); 
            tH.strokeWeight = 0;
            if (tH.strokeWeight != 0) tH.strokeWeight = 0; 
            tH.geometricBounds = [yB, xB, yT, xT];
            if (i != spMaxIndex) tH.fillColor = app.activeDocument.colors.item(histogramColor); else tH.fillColor = app.activeDocument.colors.item(histogramItemColor);
           }  // != undefined
        tV = hist.pages[0].textFrames.add();
        tV.strokeWeight = 0; 
        if (tV.strokeWeight != 0) tV.strokeWeight = 0;  
        tV.label = tfLabel;
        tV.geometricBounds = [yB+10, xB, yB+10+bottomLength, xB+xLength];  
        tV.texts[0].insertionPoints[0].appliedParagraphStyle = app.activeDocument.paragraphStyles[0];    
        tV.texts[0].insertionPoints[0].pointSize = 1;
        tV.texts[0].parentStory.contents = "";
        tV.texts[0].contents = String(i*0.1 + " пт");
        if (spaces[i] == undefined) {
            tV.texts[0].contents += " (—)";
            tV.label = ""; // фрейм без информации метки не имеет.
            }
        else {
            numCont = " (" + String(spaces[i]) + ")";
            tV.texts[0].contents += numCont;          
            }
        tV.textFramePreferences.verticalJustification = VerticalJustification.CENTER_ALIGN; 
        app.activeWindow.transformReferencePoint = AnchorPoint.CENTER_ANCHOR;
        //>> для оживления процесса создания гистограммы
        tV.geometricBounds = [yB+10, xB, yB+20+bottomLength, xB+xLength*2];  
        tV.texts[0].select();
        tV.geometricBounds = [yB+10, xB, yB+10+bottomLength, xB+xLength]; 
        //>>
        tV.rotationAngle = 90;
        if (xLength > bottomLength) tV.move (undefined, [-(tV.geometricBounds[1] - xB), 0]); else tV.move (undefined, [-(tV.geometricBounds[1] - xB), -85]);
        setPointSize (10);
        if (tV.texts[0].parentStory.overflows) setPointSize (9);
        if (tV.texts[0].parentStory.overflows) setPointSize (8);  
        if (tV.texts[0].parentStory.overflows) setPointSize (7);  
        if (tV.texts[0].parentStory.overflows) setPointSize (6);        
        } // i++
    app.documents[0].select(NothingEnum.nothing);
    myT.contents = "";
    myT.texts[0].insertionPoints[0].appliedParagraphStyle = app.activeDocument.paragraphStyles[0];
    myT.texts[0].insertionPoints[0].appliedCharacterStyle = app.activeDocument.characterStyles[0];
    // текст справки: только сообщим  стиль текста, а использоваться в этом фрейме будет базовый абзацный стиль.
    myT.texts[0].contents = "Используемый абзацный стиль: " + String (style.selection) + "\r";
    myT.texts[0].contents+= "Шрифт (кегль): " + upsFont + "  (" + upsKegl + " пт.)\r\r";
    myT.texts[0].contents += "Преобладающая ширина пробелов в выделенном тексте (сиреневый цвет): " + spMaxIndex*0.1 + " пт.\r";    
    myT.texts[0].contents += "Стандартная ширина пробела при использовании этого абзацного стиля: " + fontSpaceWidth + " пт.\r";
    myT.texts[0].contents += "Ширина буквы i: " + font_iWidth + " пт.\r";    
    myT.texts[0].contents += "Ширина буквы н: " + font_nWidth + " пт.\r";
    myT.texts[0].contents += "\rЧетверть кегля: " + quotePointsize.toFixed(2) + " пт.";
    myT.texts[0].contents += "\rТреть кегля: " + thirdSpace.toFixed(2) + " пт.";    
    myT.texts[0].contents += "\rТонкая шпация: " + thinSpace.toFixed(2) + " пт.";

    myT.texts[0].contents += "\r\rКернинг: " + upsKerning;
    myT.texts[0].contents += "\rТрекинг: " + upsTracking;        

    myT.texts[0].contents += "\rМежсловные интервалы: " + upsMinW + " | " +  upsDesW +  " | " + upsMaxW + "  (" + ((fontSpaceWidthS*upsMinW)/100).toFixed(2) + " пт. | " + ((fontSpaceWidthS*upsDesW)/100).toFixed(2) + " пт. | " + ((fontSpaceWidthS*upsMaxW)/100).toFixed(2) + " пт.)";
    myT.texts[0].contents += "\rМежбуквенные интервалы: " + upsMinL + " | " +  upsDesL + " | " + upsMaxL;
    myT.texts[0].contents += "\rМасштаб глифов: " + upsMinG + " | " +  upsDesG  + " | " + upsMaxG; 
    myT.texts[0].contents += "\rКомпоновщик: " + upsComposer;

    myT.texts[0].contents += "\r\rразмер самого широкого пробела: " + spMax.toFixed(2) + " пт.\r"; 
    compareText = "";
    if (Number(spMin) < Number(quotePointsize)) compareText = " (четверть кегля шире такого пробела)";
    myT.texts[0].contents += "размер самого узкого пробела: " + spMin.toFixed(2) + " пт." + compareText + "\r";      
    myT.texts[0].contents += "ширина узкого пробела составляет " + ((spMin/quotePointsize)*100).toFixed(1) + "% от четверти кегля.\r";  
    if (Number(spMin) <= Number(thinSpace)) myT.texts[0].contents += "Ширина узкого пробела меньше тонкой шпации!\r"; 

    app.findGrepPreferences = NothingEnum.nothing;
    app.changeGrepPreferences = NothingEnum.nothing; 
    app.findGrepPreferences.findWhat = "(\\d)(\\.)(\\d)";
    app.changeGrepPreferences.changeTo = "$1,$3"; // дробные числа должны быть с запятой, а не точкой
    myT.texts[0].changeGrep();    
    app.findGrepPreferences = NothingEnum.nothing;
    app.changeGrepPreferences = NothingEnum.nothing;     
    spaces = null;
    histDocID = app.activeDocument.id;
    showSpaces.enabled = true;
    changeSets.enabled = true;    
    return;
    } // makeHistogram.value
///
if (showSpaces.value == true) { // showSpaces.value
    clearCondition(); 
    if (app.activeDocument.id != histDocID) {
        alert("На экране должна быть последняя сделанная гистограмма. Сейчас там другой файл.",programTitul);
        return;          
        }
    if (app.documents.itemByID(startDocID).isValid == false) {
        alert("Не найден файл, информация о пробелах в котором показана в этой гистограмме.",programTitul);
        return;            
        }
    sel = app.selection[0];
    if (sel == null || (sel.parentTextFrames[0].label != tfLabel)) {
        alert("Должен быть выбран текст с информацией о ширине пробелов.",programTitul);
        return;    
        }  
    var tfInfo = sel.parentTextFrames[0].texts[0].contents;
    var sizePt_ar = [];
    while (sizePt_ar.length > 0) sizePt_ar.pop();
    sizePt_ar = tfInfo.split(" пт "); // пробел 'пт' пробел
    if (sizePt_ar.length != 2) {
        alert("Неверные данные в фрейме с информацией о ширине пробела. [1]",programTitul); // сообщение этапа отладки
        return;            
        }
    var numLength = sizePt_ar[1].length;
    if (sizePt_ar[1][0] != "(" || sizePt_ar[1][numLength-1] != ")") {
        alert("Неверные данные в фрейме с информацией о ширине пробела. [2]",programTitul); // сообщение этапа отладки
        return;            
        } 
    spacesNum = sizePt_ar[1].substring(1,numLength-1);
    app.activeDocument = app.documents.itemByID(startDocID);
    story = app.activeDocument.stories.itemByID(storyID);
    spaceValue.text = tfInfo;
    var sample = Number(sizePt_ar[0])*10;
    spacesArrSample = String(spacesArr[sample]).split(",");
    clearCondition();
    doc.conditions.add ({name:showSpaceCondition, indicatorColor:colorLightBlue, indicatorMethod:ConditionIndicatorMethod.USE_HIGHLIGHT, visible:true});
    theCondition.push(doc.conditions.item(showSpaceCondition));
    var pBar = new ProgressBar("Отмечаем цветом выбранные пробелы"); 
    pBar.reset(spacesArrSample.length);    
    for (var i = 0; i < spacesArrSample.length; i++, pBar.hit()) { // i++
        try { story.characters[spacesArrSample[i]].applyConditions (theCondition[0], true); } catch (e) { alert("Информация о позициях пробелов уже недоступна.",programTitul); return; }
        } // i++
    pBar.close();
    app.activeDocument.layoutWindows[0].screenMode = ScreenModeOptions.PREVIEW_OFF;
    app.activeWindow.activePage = story.insertionPoints[spacesArrSample[0]].parentTextFrames[0].parentPage; 
    story.characters[spacesArrSample[0]].select();
    doc.select(NothingEnum.nothing); 
    app.activeWindow.zoom (ZoomOptions.fitPage);
    return;
    } // showSpaces.value
///
if (changeSets.value) { // changeSets.value |  "Изменить установки ширины пробелов"
    app.activeDocument = app.documents.itemByID(startDocID);   
    clearCondition();   
    usedStyle = app.activeDocument.paragraphStyles.itemByID(paraStyleID[style.selection.index]);
    var usName = usedStyle.name;
    var suffix;
    if (as_thirdSpace.value == true) suffix = dupStyleSuffix_3; else suffix = dupStyleSuffix_i;
    if (psChange.value) { // psChange |  "Сделать стиль"
        var cmpN = usName.indexOf(" (4-");        
        if (cmpN != -1) {
            showMes ("В названии выбранного стиля уже есть ' (4-' . [1]");           
            return;         
            }
        var dName = usedStyle.name + suffix; 
        if (usedStyle.parent.constructor.name == "ParagraphStyleGroup") { // ParagraphStyleGroup
            var psGr = usedStyle.parent;
            if (psGr.paragraphStyles.item(dName).isValid == true) { // = true
                dupStyleID = psGr.paragraphStyles.item(dName).id;
                showMes ("Такой стиль уже есть, он в группе.");     
                return; 
                }  // = true
           } // ParagraphStyleGroup 
        if (doc.paragraphStyles.item(dName).isValid == true) { /// == true
                dupStyleID = doc.paragraphStyles.item(dName).id;
                showMes ("Такой стиль уже есть, он в обычных стилях (не в группе).");         
                return;
                } /// == true  
        else { // else
            // такого стиля ещё нет.
            dupStyle = usedStyle.duplicate();
            dupStyle.name = dName; 
            getAllSpaceValues();
            dupStyle.minimumWordSpacing = 50;  
            var theValue = Number(((font_nWidthS/fontSpaceWidthS)*100).toFixed(2));             
            dupStyle.maximumWordSpacing = theValue;
            if (as_thirdSpace.value == true) theValue = Number(((thirdSpace/fontSpaceWidthS)*100).toFixed(2));
            else theValue = Number(((font_iWidthS/fontSpaceWidthS)*100).toFixed(2));                      
            if (as_letter_i.value && font_iWidthS < quotePointsize) {
              //  dupStyle.desiredWordSpacing = 100;
                dupStyle.desiredWordSpacing = Number(((quotePointsize/fontSpaceWidthS)*100).toFixed(2));              
                dupStyle.minimumWordSpacing = theValue;                    
                } 
             else {
                dupStyle.desiredWordSpacing = theValue;
                //dupStyle.minimumWordSpacing = 100;    
                dupStyle.minimumWordSpacing = Number(((quotePointsize/fontSpaceWidthS)*100).toFixed(2));                
                }
            var nN = String (style.selection) + suffix;
            var _stylePosition = Number(style.selection.index);
            collectParastyles();
            updateList (style, paraStyles);
            style.selection = _stylePosition;
            style.helpTip = String (style.selection);
            showMes ("Стиль создан, в его названии есть " + suffix + ".");  
            return;
            }  // else
        } // psChange
    else { /// psApply.value  |  "Применение" 
        var _sel = app.selection[0];
        var indexOld = Number(styleOld.selection.index);
        var indexNew = Number(styleNew.selection.index);     
        if (indexOld == indexNew) {
            showMes ("Новый и заменяемый стили одинаковые.");
            return;             
            }
        var oldStyleID = paraStyleID[indexOld];
        var newStyleID = paraStyleID[indexNew];        
        app.findGrepPreferences = NothingEnum.nothing;
        app.changeGrepPreferences = NothingEnum.nothing;
        app.findGrepPreferences.appliedParagraphStyle = app.activeDocument.paragraphStyles.itemByID(oldStyleID);
       // app.changeGrepPreferences.appliedParagraphStyle = app.activeDocument.paragraphStyles.itemByID(newStyleID);
        var findRez = _sel.findGrep(); 
        if (findRez.length == 0) {
            showMes ("Стиль не найден, поэтому замена не выполнена.");
            return; 
            }
        for (var i = findRez.length-1; i >= 0; i--) { // i--
            // замена стиля с сохранением локального форматирования
            findRez[i].applyParagraphStyle(app.activeDocument.paragraphStyles.itemByID(newStyleID), false);
            } // i--  
        showMes ("Стиль изменён.");
        return;            
        }  /// psApply.value
    }  // changeSets.value
}  // action
///
function getAllSpaceValues() { // getAllSpaceValues
var mySampleTextFrame = doc.pages[0].textFrames.add({geometricBounds:["-12mm","0mm","0mm","100mm"]});
mySampleTextFrame.strokeWeight = 0;
if (mySampleTextFrame.strokeWeight != 0) mySampleTextFrame.strokeWeight = 0;    
mySampleTextFrame.texts[0].insertionPoints[0].appliedParagraphStyle = usedStyle;
app.activeDocument.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.POINTS;
mySampleTextFrame.texts[0].contents = "nnnn i н."; // эти буквы уже оформлены нужным абзацным стилем
mySampleTextFrame.texts[0].paragraphs[0].justification = Justification.LEFT_ALIGN;
// сделаем для измерений такие установки: ширины пробелов по 100%, межбуквенные пробелы по 0% и глифы 100%
mySampleTextFrame.texts[0].minimumWordSpacing = 0;
mySampleTextFrame.texts[0].desiredWordSpacing = 0;
mySampleTextFrame.texts[0].maximumWordSpacing = 0;   
mySampleTextFrame.texts[0].maximumWordSpacing = 100;   
mySampleTextFrame.texts[0].desiredWordSpacing = 100;
mySampleTextFrame.texts[0].minimumWordSpacing = 100; 

mySampleTextFrame.texts[0].minimumLetterSpacing = -10;
mySampleTextFrame.texts[0].desiredLetterSpacing = 0;
mySampleTextFrame.texts[0].maximumLetterSpacing = 0;   
mySampleTextFrame.texts[0].minimumLetterSpacing = 0;    

mySampleTextFrame.texts[0].minimumGlyphScaling = 90;
mySampleTextFrame.texts[0].desiredGlyphScaling =100;
mySampleTextFrame.texts[0].maximumGlyphScaling = 100;   
mySampleTextFrame.texts[0].minimumGlyphScaling = 100;      

font_iWidthS = Math.abs(mySampleTextFrame.texts[0].characters[5].endHorizontalOffset - mySampleTextFrame.texts[0].characters[5].horizontalOffset); // i
font_iWidth = font_iWidthS.toFixed(2);     
fontSpaceWidthS = Math.abs(mySampleTextFrame.texts[0].characters[6].endHorizontalOffset - mySampleTextFrame.texts[0].characters[6].horizontalOffset); // пробел
fontSpaceWidth = fontSpaceWidthS.toFixed(2);  
font_nWidthS = Math.abs(mySampleTextFrame.texts[0].characters[7].endHorizontalOffset - mySampleTextFrame.texts[0].characters[7].horizontalOffset);  // н
font_nWidth = font_nWidthS.toFixed(2);    

quotePointsize = Number(mySampleTextFrame.texts[0].characters[5].pointSize)/4;
thinSpace = Number(mySampleTextFrame.texts[0].characters[5].pointSize)/8;
thirdSpace = Number(mySampleTextFrame.texts[0].characters[5].pointSize)/3;    
upsFont = usedStyle.appliedFont.name;
upsKegl = usedStyle.pointSize;

upsKerning = usedStyle.kerningMethod;
upsTracking = usedStyle.tracking;        

upsMinW = Number(usedStyle.minimumWordSpacing);  
upsDesW = Number(usedStyle.desiredWordSpacing);
upsMaxW = Number(usedStyle.maximumWordSpacing);

upsMinL = Number(usedStyle.minimumLetterSpacing);
upsDesL = Number(usedStyle.desiredLetterSpacing);
upsMaxL = Number(usedStyle.maximumLetterSpacing);

upsMinG = Number(usedStyle.minimumGlyphScaling);
upsDesG = Number(usedStyle.desiredGlyphScaling);
upsMaxG = Number(usedStyle.maximumGlyphScaling); 

upsComposer = usedStyle.composer;      
mySampleTextFrame.remove();
return;
} // getAllSpaceValues
///
function setPointSize (value) { // setPointSize
var storyLength = tV.texts[0].parentStory.length;
tV.texts[0].parentStory.characters.itemByRange(0,storyLength-1).pointSize = value;
return;    
} // setPointSize 
///
win.onClose = function() { // onClose
try {    
 // если все файлы закрыты, а окно скрипта на экране осталось, то надо пройти все обращения к doc без вывода сооющения об ошибке.   
    doc.viewPreferences.horizontalMeasurementUnits = horUnit;
    doc.viewPreferences.verticalMeasurementUnits = vertUnit;
    myDataFile.open("w");
    myDataFile.writeln(style.selection);
    myDataFile.writeln(Number(style.selection));
    myDataFile.close();
    app.findGrepPreferences = app.changeGrepPreferences = null;  
    spacesArr = null;
    clearCondition();
    try { app.activeDocument.colors.item(lastLineColor).remove(); } catch (e) { }   
    doc.select(NothingEnum.nothing);
    }
catch (e) { }
app.activate();
} // onClose
///
info.onClick = function() { // info.onClick
app.pdfExportPreferences.properties.viewPDF = true;   
var myScriptFile = myGetScriptPath();
var myScriptFolder = decodeURI(myScriptFile.path);  
var pdfName = "DoSpacesOKinfo.pdf";
var infoFile = File(decodeURI(myScriptFolder + "/Info/" + pdfName));
if (infoFile.exists == false) { 
    alert("Не найден PDF-файл с описанием этой программы. Он называется '" + pdfName + "' и должен быть в папке 'Info' этого скрипта.",programTitul);
    return; 
    }
else {
        infoFile.execute();
        return;
    }
} // info.onClick
///
win.show();
////
function myGetScriptPath() { // myGetScriptPath
try { return app.activeScript; }
catch(e) { return File(e.fileName); }
} // myGetScriptPath()
////
function showMes(mes) { // showMes
var ewin = new Window ("palette", mes, {x:0, y:0, width:600, height:12}); 
ewin.center();
ewin.show();
ewin.update();   
$.sleep(2500);
ewin.close();
app.activate();
return;
} // showMes
